---
title: CanvasRenderingContext2D.direction
slug: Web/API/CanvasRenderingContext2D/direction
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Experimental
  - Property
  - Reference
---
<div>{{APIRef}} {{SeeCompatTable}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.direction</code></strong> property of the Canvas 2D API specifies the current text direction used to draw text.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.direction = "ltr" || "rtl" || "inherit";
</pre>

<h3 id="Options">Options</h3>

<p>Possible values:</p>

<dl>
 <dt><code>"ltr"</code></dt>
 <dd>The text direction is left-to-right.</dd>
 <dt><code>"rtl"</code></dt>
 <dd>The text direction is right-to-left.</dd>
 <dt><code>"inherit"</code></dt>
 <dd>The text direction is inherited from the {{HTMLElement("canvas")}} element or the {{domxref("Document")}} as appropriate. Default value.</dd>
</dl>

<p>The default value is <code>"inherit"</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Changing_text_direction">Changing text direction</h3>

<p>This example draws two pieces of text. The first one is left-to-right, and the second is right-to-left. Note that "Hi!" in <code>ltr</code> becomes "!Hi" in <code>rtl</code>.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[6]">var canvas = document.getElementById('canvas');
var ctx = canvas.getContext('2d');

ctx.font = '48px serif';
ctx.fillText('Hi!', 150, 50);
ctx.direction = 'rtl';
ctx.fillText('Hi!', 150, 130);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Changing_text_direction', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-direction", "CanvasRenderingContext2D.direction")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.direction")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this property: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
